;  .ini file structure read/write example by Mark Jones 2005
include masm32rt.inc                                ; MASM v8.2 SP2a+ RTL's

.data                                               ; preinitialized (file) vars
    iniName     db  '\test.ini',0                   ; file to create
    iniSection  db  'MyApp',0                       ; section text
    iniKey      db  'OFN1',0                        ; key text
    
    ofnFilter   db  'All Files',0,'*.*',0,0         ; OpenFileName filter
    ofnTitle    db  'Select a File',0               ; OpenFileName title

.data?                                              ; runtime (ram) variables
    hConsole    dd  ?                               ; handle of console app
    CurrentDir  db  256 dup(?)                      ; path to .ini file
    OFN1        OPENFILENAME<>                      ; used with GetOpenFileName
    ofnPath     db  256 dup(?)                      ; path to OFN file
    OFN2        OPENFILENAME<>                      ; structure to be filled
    
.code
main:
    invoke GetStdHandle,hConsole                    ; get console handle
    invoke GetCurrentDirectory,255,addr CurrentDir  ; get current dir
    invoke lstrcat,addr CurrentDir,addr iniName     ; append filename to it
    
    mov OFN1.lStructSize,sizeof OFN1                ; setup "open file" struct
    m2m OFN1.hwndOwner,hConsole                     ; 'm2m' is a macro
;   m2m OFN1.hInstance,hInstance                    ; not applicable
    mov OFN1.lpstrFilter,offset ofnFilter           ; file filter
    mov OFN1.lpstrFile,offset ofnPath               ; file path
    mov OFN1.lpstrTitle,offset ofnTitle             ; title
    mov OFN1.nMaxFile,255                           ; reserve a null 
    mov OFN1.Flags,OFN_HIDEREADONLY or OFN_NOREADONLYRETURN
    
    print chr$(" Console .ini file test by MCJ 2005",13,10)
    mov eax,input(13,10," Press enter to create test.ini file:")
    call writeit
    mov eax,input(13,10," Press enter to display test.ini:")
    invoke ShellExecute,hConsole,0,addr CurrentDir,0,0,SW_SHOW
    mov eax,input(13,10," Press enter to read test.ini file:")
    call readit
    mov eax,input(13,10," Press enter to use read structure:")
@@:
    invoke GetOpenFileName,offset OFN2              ; ask for a file
    .if eax==0                                      ; if nothing returned,
        invoke Beep,100,1000                        ; complain...
        jmp @B                                      ; and ask again :)
    .endif
    print chr$(13,10," Selected file: ")            ; OFN2.lpstrFile is
    print OFN2.lpstrFile                            ; already a pointer
    print chr$(13,10)                               ; so ADDR is not needed
    mov eax,input(13,10," Press enter to exit.")
    invoke ExitProcess,0                            ; exit gracefully


writeit proc                                        ; write ini file
    invoke WritePrivateProfileStruct,addr iniSection,addr iniKey,\
           addr OFN1,OFN1.lStructSize,addr CurrentDir
    .if eax==0                                      ; if there was an error,
        invoke Beep,100,1000                        ; let us know
    .endif
    ret
writeit endp

readit  proc                                        ; read ini file
    invoke GetPrivateProfileStruct,addr iniSection,addr iniKey,\
           addr OFN2,OFN1.lStructSize,addr CurrentDir
    .if eax==0
        invoke Beep,100,1000
    .endif
    ret
readit  endp


end main
